/**
  SwitchHosts
  Copyright (C) 2009-2009 Takashi Ishikawa.
  http://switchhosts.mozdev.org/

  This source code is released under the GPL license,
  available in the LICENSE file at the root of this installation
  and also online at http://www.gnu.org/licenses/gpl.txt
**/

Components.utils.import("resource://modules/PaidonUtil.jsm");
Components.utils.import("resource://modules/PaidonLogger.jsm");
Components.utils.import("resource://modules/SWFactory.jsm");
Components.utils.import("resource://modules/SWConst.jsm");

if(!org) var org={};
if(!org.mozdev) org.mozdev={};
if(!org.mozdev.switchhosts) org.mozdev.switchhosts={};

org.mozdev.switchhosts.FirefoxStatusBar = function() {

  this.myName = "SwitchHosts";

  this.init = function() {
      this.logger = SWFactory.getLogger(this);

      this.label = document.getElementById('switchhosts-status-bar-label');
      this.tooltip = document.getElementById('switchhosts-status-bar-tooltip');
  };

    this.update = function(host, ips, topic, name, isApplyDomain){
        this.logger.debug("Updating label: " + ips);
//        this.cleanTooltip();
          if(isApplyDomain){
            this.label.setAttribute("class","applycolor");
          }else{
            this.label.setAttribute("class","notapplycolor");
          }
          //Status bar label
          if (host && ips && ips.length) {
              var j = 0;
              var text = ips[j];
              if(topic == SWConst.EVENT_REFRESH_DNS){
                  text = "Switched: " + text;
                  this.label.value = text;
                  var x = 0;
                  for (var i = 0; i < 10; i++) {
                      setTimeout("document.getElementById('switchhosts-status-bar-label').value = '" + text + ":" + name + "'", 1000 - x);
                      var text = text.substring(1);
                      x -= 100;
                  }
              }else{
                this.label.value = text + ":" + name;
              }
//              this.updateTooltip(host, ips);
          }
          else {
              this.label.value = this.myName + ":" + name;
          }

    };

//    this.cleanTooltip = function(){
//        //Remove old tooltips
//        while (this.tooltip.childElementCount) {
//            this.tooltip.removeChild(this.tooltip.children[0]);
//        }
//        this.tooltip.setAttribute("style", "display:none;");
//    };
//
//    this.updateTooltip = function(host, ips){
//        //Tooltip title
//        var tooltipTitle = document.createElement("label");
//        tooltipTitle.setAttribute("value", "IP(s) for host: " + host);
//        tooltipTitle.setAttribute("style", "font-weight:bold;");
//        //Children
//        this.tooltip.appendChild(tooltipTitle);
//        this.tooltip.setAttribute("style", "padding:2px;");
//        for (var i = 0; i < ips.length; i++) {
//            var label = document.createElement("label");
//            label.setAttribute("value", ips[i]);
//            this.tooltip.appendChild(label);
//        }
//    };

};

org.mozdev.switchhosts.FirefoxMenu = function() {

  this.init = function() {

      this.logger = SWFactory.getLogger(this);

    //Observer
    SwitchHosts.addObserver(this, SWConst.EVENT_SAVE_HOSTS_FILE);
    SwitchHosts.addObserver(this, SWConst.EVENT_SELECT_HOSTS);
    SwitchHosts.addObserver(this, SWConst.EVENT_REMOVE_HOSTS_FILE);
    SwitchHosts.addObserver(this, SWConst.EVENT_LOCATION_CHANGE);
    SwitchHosts.addObserver(this, SWConst.EVENT_REFRESH_DNS);
    SwitchHosts.addObserver(this, SWConst.EVENT_OSHOSTS_CHANGED);

    //ʗvf
    this.menubar = document.getElementById('switchhosts-menu-list');
    this.context = document.getElementById('switchhosts-context-list');

    this.statusBar = new org.mozdev.switchhosts.FirefoxStatusBar();
    this.statusBar.init();

    this.clear();
    var label = SwitchHosts.getCurrentHosts().getName();
    this.update(label);

  };

  this.observe = function(subject, topic, data){
    if(topic == SWConst.EVENT_SAVE_HOSTS_FILE || topic == SWConst.EVENT_REMOVE_HOSTS_FILE){
      this.clear();
      var label = SwitchHosts.getCurrentHosts().getName();
      this.update(label);
    }
    if(topic == SWConst.EVENT_SELECT_HOSTS){ this.select(data); }
    if(topic == SWConst.EVENT_LOCATION_CHANGE || topic == SWConst.EVENT_REFRESH_DNS){
      var datas = data.split(",");
      var name = datas[0];
      datas.shift();
      var host = datas[0];
      datas.shift();
      var ips = datas;

      //ANZXhCHostsɓo^Ă邩mF
      var isApplyDomain = false;
      var aRecords = SwitchHosts.getCurrentHosts().getRecords();
this.logger.debug("aRecords=" + aRecords);
      for(var i=0; i<aRecords.length; i++){
        if(host == aRecords[i].getHost()){
          isApplyDomain = true;
        }
      }
this.logger.debug("isApplyDomain=" + isApplyDomain);
      this.statusBar.update(host, ips, topic, name, isApplyDomain);
    }
    if(topic == SWConst.EVENT_OSHOSTS_CHANGED){
      var alertsFile = "chrome://switchhosts/content/alternateAlert.xul";
      var newOptions = { title: SwitchHosts.getProperty("popup.audit.title"), text: "\n\n" + SwitchHosts.getProperty("popup.audit.content") + "\n\n\n\n", enableSound : true};
      window.openDialog(alertsFile, "alert:alert",
            "chrome,dialog=yes,titlebar=yes,popup=yes", newOptions );
    }
  };

  this.update = function(sSelectedLabel){

    //Get and Sort Elements
    var aHosts = SwitchHosts.getHostsList();

    //Add to list
    for(var i = 0; i < aHosts.length; i++){
      this.appendItem(aHosts[i].getName(), aHosts[i].getUri());
    }
    this.select(sSelectedLabel);

  };

  this.clear = function(){
    //Context
    var aNodes = this.context.childNodes;
    for(var i = aNodes.length-1; i >= 0; i--){
      if(aNodes[i].getAttribute("class") == "switchhosts-context-item")
        this.context.removeChild(aNodes[i]);
    }

    //MenuBar
    aNodes = this.menubar.childNodes;
    for(var i = aNodes.length-1; i >= 0; i--){
      if(aNodes[i].getAttribute("class") == "switchhosts-menu-item")
        this.menubar.removeChild(aNodes[i]);
    }

  };

  this.appendItem = function(sLabel, sValue){
    var oItem = null;

    //Context List
    var oSeparator = document.getElementById("switchhosts-context-list-separator");
    oItem = document.createElement("menuitem");
//    oItem.setAttribute("id", sValue);
    oItem.setAttribute("label", sLabel);
    oItem.setAttribute("value", sValue);
    oItem.setAttribute("type", "checkbox");
    oItem.setAttribute("autocheck", "false");
    oItem.setAttribute("class", "switchhosts-context-item");
    oItem.setAttribute("oncommand", "SwitchHosts.selectHosts(this.label, this.value);");
    this.context.insertBefore(oItem, oSeparator);

    //MenuBar
    oSeparator = document.getElementById("switchhosts-menu-list-separator");
    oItem = document.createElement("menuitem");
//    oItem.setAttribute("id", sValue);
    oItem.setAttribute("label", sLabel);
    oItem.setAttribute("value", sValue);
    oItem.setAttribute("type", "checkbox");
    oItem.setAttribute("autocheck", "false");
    oItem.setAttribute("class", "switchhosts-menu-item");
    oItem.setAttribute("oncommand", "SwitchHosts.selectHosts(this.label, this.value);");
    this.menubar.insertBefore(oItem, oSeparator);

    return oItem;
  };

  this.select = function(sLabel){

    //Context
    var oItem = this.context.getElementsByAttribute("label", sLabel);

    //Uncheck Other
    var aChecked = this.context.getElementsByAttribute("checked", "true");
    for(var c = 0; c < aChecked.length; c++){
      aChecked[c].setAttribute("checked", false);
    }


    if(oItem){
      //Select
      oItem = oItem[0];
      if(oItem){
        this.context.selectedItem = oItem;
        oItem.setAttribute("selected", true);
        oItem.setAttribute("checked", true);
      }
    }

    //MenuBar
    oItem = this.menubar.getElementsByAttribute("label", sLabel);

    //Uncheck Other
    var aChecked = this.menubar.getElementsByAttribute("checked", "true");
    for(var c = 0; c < aChecked.length; c++){
      aChecked[c].setAttribute("checked", false);
    }

    if(oItem){
      //Check Selected
      oItem = oItem[0];
      if(oItem){
        this.menubar.selectedItem = oItem;
        oItem.setAttribute("selected", true);
        oItem.setAttribute("checked", true);
      }
    }

  };

  this.destroy = function(){
    SwitchHosts.removeObserver(this, SWConst.EVENT_SAVE_HOSTS_FILE);
    SwitchHosts.removeObserver(this, SWConst.EVENT_SELECT_HOSTS);
    SwitchHosts.removeObserver(this, SWConst.EVENT_REMOVE_HOSTS_FILE);
    SwitchHosts.removeObserver(this, SWConst.EVENT_LOCATION_CHANGE);
    SwitchHosts.removeObserver(this, SWConst.EVENT_REFRESH_DNS);
    SwitchHosts.removeObserver(this, SWConst.EVENT_OSHOSTS_CHANGED);
  };

};
