/**
  SwitchHosts
  Copyright (C) 2009-2009 Takashi Ishikawa.
  http://switchhosts.mozdev.org/

  This source code is released under the GPL license,
  available in the LICENSE file at the root of this installation
  and also online at http://www.gnu.org/licenses/gpl.txt
**/

Components.utils.import("resource://modules/PaidonUtil.jsm");
Components.utils.import("resource://modules/PaidonLogger.jsm");
Components.utils.import("resource://modules/SWFactory.jsm");
Components.utils.import("resource://modules/SWConst.jsm");

if(!org) var org={};
if(!org.mozdev) org.mozdev={};
if(!org.mozdev.switchhosts) org.mozdev.switchhosts={};

org.mozdev.switchhosts.HostsManageDialog = function(){

  this.init = function(){

    this.logger = SWFactory.getLogger(this);

    SwitchHosts.addObserver(this, SWConst.EVENT_SAVE_HOSTS_FILE);
    SwitchHosts.addObserver(this, SWConst.EVENT_REMOVE_HOSTS_FILE);

    //ʗvf
    this.managelist = document.getElementById('switchhosts-manage-list');

    this.update();

    sizeToContent();

  };

  this.edit = function(iType) {

    var oEditItem = this.managelist.selectedItem;

    //Edit
    if(iType == 2){
      window.openDialog("chrome://SwitchHosts/content/HostsFileEditDialog.xul","HostsFileEditDialog","centerscreen, chrome", "edit", oEditItem.value);
    }
    //Add
    else if(iType == 1){
      window.openDialog("chrome://SwitchHosts/content/HostsFileEditDialog.xul","HostsFileEditDialog","centerscreen, chrome", "add", "");
    //Copy
    }else{
      window.openDialog("chrome://SwitchHosts/content/HostsFileEditDialog.xul","HostsFileEditDialog","centerscreen, chrome", "copy", oEditItem.value);
    }
  };

  this.remove = function(){
    var oEditItem = this.managelist.selectedItem;

    if(oEditItem.value == SwitchHosts.getCurrentHosts().getUri()){
      SwitchHosts.alertErrorMessage("error.hosts.remove.active");
      return;
    }

    if(SwitchHosts.confirmMessage("hosts.remove.confirm", [ oEditItem.label] )){
      SwitchHosts.removeHosts(oEditItem.value);
    }

  };

  this.observe = function(subject, topic, data){
    if(topic == SWConst.EVENT_SAVE_HOSTS_FILE){ this.clear(); this.update(); }
    if(topic == SWConst.EVENT_REMOVE_HOSTS_FILE){ this.clear(); this.update(); }
  };

  this.update = function(sSelectedLabel){

    //Get and Sort Elements
    var aHosts = SwitchHosts.getHostsList();

    //Add to list
    for(var i = 0; i < aHosts.length; i++){
      var oItem = this.appendItem(aHosts[i].getName(), aHosts[i].getUri(), false);
    }

  };

  this.clear = function(){
    var aNodes = this.managelist.childNodes;
    for(var i = aNodes.length-1; i >= 0; i--){
      this.managelist.removeChild(aNodes[i]);
    }
  };

  this.appendItem = function(sLabel, sValue){
    var oItem = this.managelist.appendItem(sLabel, sValue);
  };

  this.destroy = function(){
    SwitchHosts.removeObserver(this, SWConst.EVENT_SAVE_HOSTS_FILE);
    SwitchHosts.removeObserver(this, SWConst.EVENT_REMOVE_HOSTS_FILE);
  };

};

var main = new org.mozdev.switchhosts.HostsManageDialog();
window.addEventListener("load", function(){
    main.init();
}, false);
window.addEventListener("unload", function(){
    main.destroy();
}, false);
