/**
  SwitchHosts
  Copyright (C) 2009-2009 Takashi Ishikawa.
  http://switchhosts.mozdev.org/

  This source code is released under the GPL license,
  available in the LICENSE file at the root of this installation
  and also online at http://www.gnu.org/licenses/gpl.txt
**/

Components.utils.import("resource://modules/PaidonUtil.jsm");
Components.utils.import("resource://modules/SWFactory.jsm");

if(!org) var org={};
if(!org.mozdev) org.mozdev={};
if(!org.mozdev.switchhosts) org.mozdev.switchhosts={};

org.mozdev.switchhosts.PreferenceDialog = function(){

  this.beforeSavePath = "";

  this.init = function(){
    this.updateUI();
    this.beforeSavePath = document.getElementById("save.path").value.path;
    sizeToContent();
  };

  this.updateUI = function(){
      var file = document.getElementById("save.path").value;
      if (file) {
          var fileField = document.getElementById("myFileField");
          fileField.file = file;
          fileField.label = file.path;
      }
  };

  this.selectDir = function(){
      var filePicker = Components.classes["@mozilla.org/filepicker;1"]
                       .createInstance(Components.interfaces.nsIFilePicker);
      filePicker.init(window, "Choose a folder.", filePicker.modeGetFolder);
      if (filePicker.show() == filePicker.returnOK && SwitchHosts.checkPermission(filePicker.file.path)){
          document.getElementById("save.path").value = filePicker.file;
          this.updateUI();
      }
  };

  this.save = function(){
    var fileField = document.getElementById("myFileField");
    SwitchHosts.changeSaveHostsPath(this.beforeSavePath, fileField.label);
    return true;
  };

  this.loadDefault = function(){
    SwitchHosts.changeSaveDefaultHostsPath();
    this.updateUI();
  };

  this.destroy = function(){
  };

};

var main = new org.mozdev.switchhosts.PreferenceDialog();
window.addEventListener("load", function(){
    main.init();
}, false);
window.addEventListener("unload", function(){
    main.destroy();
}, false);
