/**
  SwitchHosts
  Copyright (C) 2009-2009 Takashi Ishikawa.
  http://switchhosts.mozdev.org/

  This source code is released under the GPL license,
  available in the LICENSE file at the root of this installation
  and also online at http://www.gnu.org/licenses/gpl.txt
**/

Components.utils.import("resource://modules/PaidonUtil.jsm");
Components.utils.import("resource://modules/PaidonLogger.jsm");
Components.utils.import("resource://modules/PaidonDns.jsm");
Components.utils.import("resource://modules/PaidonDataSource.jsm");
Components.utils.import("resource://modules/PaidonFile.jsm");
Components.utils.import("resource://modules/PaidonResource.jsm");
Components.utils.import("resource://modules/PaidonPreference.jsm");
Components.utils.import("resource://modules/SWConst.jsm");

var EXPORTED_SYMBOLS = ["SWFactory"];

const Cc = Components.classes;
const Ci = Components.interfaces;
var Application = Cc["@mozilla.org/fuel/application;1"].getService(Ci.fuelIApplication);

var SWFactory = {

  getDataSource : function(){
    if(!this.datasource){
      this.datasource = new PaidonDataSource(SWConst.RDF_ROOT);
    }
    return this.datasource;
  },

  getResource : function(){
    if(!this.resource){
      this.resource = new PaidonResource(SWConst.LOCAL_PROPERTIES_PATH);
    }
    return this.resource;
  },

  getPreference : function(){
    if(!this.preference){
      this.preference = new PaidonPreference(SWConst.PREF_BRANCH_NAME);
    }
    return this.preference;
  },

  getLogger : function(obj){
    if(!this.logger){
      this.logger = new PaidonLogger(this.getPreference().getBool("log.enable"));
    }
    return this.logger;
  },

  getDns : function(obj){
    if(!this.dns){
      this.dns = new PaidonDns(obj);
    }
    return this.dns;
  },

  getHostsManager : function(){
    Components.utils.import("resource://modules/SWHostsManager.jsm");
    if(!this.hostsManager){
      this.hostsManager = new SWHostsManager();
    }
    return this.hostsManager;
  },

  getObserver : function(){
    Components.utils.import("resource://modules/SWObserver.jsm");
    if(!this.observer){
      this.observer = new SWObserver();
    }
    return this.observer;
  }

};
