/**
  SwitchHosts
  Copyright (C) 2009-2009 Takashi Ishikawa.
  http://switchhosts.mozdev.org/

  This source code is released under the GPL license,
  available in the LICENSE file at the root of this installation
  and also online at http://www.gnu.org/licenses/gpl.txt
**/

Components.utils.import("resource://modules/PaidonUtil.jsm");
Components.utils.import("resource://modules/PaidonLogger.jsm");
Components.utils.import("resource://modules/SWFactory.jsm");
Components.utils.import("resource://modules/SWConst.jsm");

var EXPORTED_SYMBOLS = ["SWObserver"];

const Cc = Components.classes;
const Ci = Components.interfaces;
var Application = Cc["@mozilla.org/fuel/application;1"].getService(Ci.fuelIApplication);

function SWObserver() {

  this.logger = SWFactory.getLogger(this);

  this.observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);

  this.addObserver = function(object, eventName){
    this.observerService.addObserver(object, eventName, false);
  };

  this.notifySaveHostsFile = function(sHostsName){
      //notify
      this.observerService.notifyObservers(null, SWConst.EVENT_SAVE_HOSTS_FILE, sHostsName);
  };

  this.notifyRemoveHostsFile = function(sHostsUri){
      //notify
      this.observerService.notifyObservers(null, SWConst.EVENT_REMOVE_HOSTS_FILE, sHostsUri);
  };

  this.notifySelectHosts = function(sHostsName){
      //notify
      this.observerService.notifyObservers(null, SWConst.EVENT_SELECT_HOSTS, sHostsName);
  };

  this.notifyChangeLocation = function(sHostsName, sHost, aIp){
    var data = [];

    data[0] = sHostsName;
    data[1] = sHost;
    data[2] = aIp;

      //notify
      this.observerService.notifyObservers(null, SWConst.EVENT_LOCATION_CHANGE, data);
  };

  this.notifyRefreshDns = function(sHostsName, sHost, aIp){
    var data = [];

    data[0] = sHostsName;
    data[1] = sHost;
    data[2] = aIp;

      //notify
      this.observerService.notifyObservers(null, SWConst.EVENT_REFRESH_DNS, data);
  };

  this.notifyOsHostsChanged = function(sHostsName, sHost, aIp){

    var data = [];

    data[0] = sHostsName;
    data[1] = sHost;
    data[2] = aIp;

      //notify
      this.observerService.notifyObservers(null, SWConst.EVENT_OSHOSTS_CHANGED, data);
  };

  this.removeObserver = function(object, eventName){
    this.observerService.removeObserver(object, eventName);
  };

};
